// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../../core/decorator/CommandHandlerDecorator";
import AccountService from "../../../../../service/account/AccountService";
import ValidationService from "../../../../../service/validation/ValidationService";
import { GrantKycCommand, GrantKycCommandResponse } from "./GrantKycCommand";
import TransactionService from "../../../../../service/transaction/TransactionService";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import BigDecimal from "../../../../../../domain/context/shared/BigDecimal";
import { SecurityRole } from "../../../../../../domain/context/security/SecurityRole";
import { Terminal3Vc } from "../../../../../../domain/context/kyc/Terminal3";
import { verifyVc } from "@terminal3/verify_vc";
import { InvalidVc } from "../../../../../../domain/context/security/error/operations/InvalidVc";
import ContractService from "../../../../../service/contract/ContractService";
import { GrantKycCommandError } from "./error/GrantKycCommandError";
import { KycStatus } from "../../../../../../domain/context/kyc/Kyc";
let GrantKycCommandHandler = class GrantKycCommandHandler {
    accountService;
    contractService;
    transactionService;
    validationService;
    constructor(accountService, contractService, transactionService, validationService) {
        this.accountService = accountService;
        this.contractService = contractService;
        this.transactionService = transactionService;
        this.validationService = validationService;
    }
    async execute(command) {
        try {
            const { securityId, targetId, vcBase64 } = command;
            const signedCredential = Terminal3Vc.vcFromBase64(vcBase64);
            const verificationResult = await verifyVc(signedCredential);
            if (!verificationResult.isValid) {
                throw new InvalidVc();
            }
            const handler = this.transactionService.getHandler();
            const account = this.accountService.getCurrentAccount();
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const targetEvmAddress = await this.accountService.getAccountEvmAddress(targetId);
            const [issuer, updatedSignedCredential] = await this.validationService.checkValidVc(signedCredential, targetEvmAddress, securityId);
            const issuerEvmAddress = await this.accountService.getAccountEvmAddress(issuer);
            await this.validationService.checkPause(securityId);
            await this.validationService.checkRole(SecurityRole._KYC_ROLE, account.id.toString(), securityId);
            await this.validationService.checkKycAddresses(securityId, [targetId], KycStatus.NOT_GRANTED);
            const res = await handler.grantKyc(securityEvmAddress, targetEvmAddress, updatedSignedCredential.id, BigDecimal.fromString(updatedSignedCredential.validFrom.substring(0, 10)), BigDecimal.fromString(updatedSignedCredential.validUntil.substring(0, 10)), issuerEvmAddress, securityId);
            return Promise.resolve(new GrantKycCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new GrantKycCommandError(error);
        }
    }
};
GrantKycCommandHandler = __decorate([
    CommandHandler(GrantKycCommand),
    __param(0, lazyInject(AccountService)),
    __param(1, lazyInject(ContractService)),
    __param(2, lazyInject(TransactionService)),
    __param(3, lazyInject(ValidationService)),
    __metadata("design:paramtypes", [AccountService,
        ContractService,
        TransactionService,
        ValidationService])
], GrantKycCommandHandler);
export { GrantKycCommandHandler };
